#############################################################
#
#   Program: linear_models.R
#   Project: 
#   PI: 
#   Statistican/Programmer: Meridith Blevins, MS
#   Purpose: 
#   Notes: 
#   Created: 
#   Revisions: 
#     
#
#############################################################
format2 <- function(x){
    y <- format(round(x,2),nsmall=2,scientific=FALSE)
    return(y)
}

library(rms)
ols.dd1 <- datadist(analysis)
options(datadist='ols.dd1')

ols_p1o1 <- ols(tnf_ar1_diff ~  log_endocab_igg_diff + tnf_ar1_base + log_endocab_igg_base, data=analysis)
ols_p2o1 <- ols(tnf_ar1_diff ~  log_endocab_igm_diff + tnf_ar1_base + log_endocab_igm_base, data=analysis)
ols_p3o1 <- ols(tnf_ar1_diff ~  log_lbp_diff + tnf_ar1_base + log_lbp_base, data=analysis)
ols_p4o1 <- ols(tnf_ar1_diff ~  log_cd14_diff + tnf_ar1_base + log_cd14_base, data=analysis)
ols_p5o1 <- ols(tnf_ar1_diff ~  log_lac_linear_diff + tnf_ar1_base + lac_linear_base, data=analysis)
ols_p6o1 <- ols(tnf_ar1_diff ~  log_lac_quad_diff + tnf_ar1_base + log_lac_quad_base, data=analysis)
ols_p1o2 <- ols(crp_diff ~  log_endocab_igg_diff + crp_base_mgl + log_endocab_igg_base, data=analysis)
ols_p2o2 <- ols(crp_diff ~  log_endocab_igm_diff + crp_base_mgl + log_endocab_igm_base, data=analysis)
ols_p3o2 <- ols(crp_diff ~  log_lbp_diff + crp_base_mgl + log_lbp_base, data=analysis)
ols_p4o2 <- ols(crp_diff ~  log_cd14_diff + crp_base_mgl + log_cd14_base, data=analysis)
ols_p5o2 <- ols(crp_diff ~  log_lac_linear_diff + crp_base_mgl + lac_linear_base, data=analysis)
ols_p6o2 <- ols(crp_diff ~  log_lac_quad_diff + crp_base_mgl + log_lac_quad_base, data=analysis)
ols_p1o3 <- ols(cd163_diff ~  log_endocab_igg_diff + cd163_base + log_endocab_igg_base, data=analysis)
ols_p2o3 <- ols(cd163_diff ~  log_endocab_igm_diff + cd163_base + log_endocab_igm_base, data=analysis)
ols_p3o3 <- ols(cd163_diff ~  log_lbp_diff + cd163_base + log_lbp_base, data=analysis)
ols_p4o3 <- ols(cd163_diff ~  log_cd14_diff + cd163_base + log_cd14_base, data=analysis)
ols_p5o3 <- ols(cd163_diff ~  log_lac_linear_diff + cd163_base + lac_linear_base, data=analysis)
ols_p6o3 <- ols(cd163_diff ~  log_lac_quad_diff + cd163_base + log_lac_quad_base, data=analysis)
ols_p1o4 <- ols(lac_linear_diff ~  log_endocab_igg_diff + lac_linear_base + log_endocab_igg_base, data=analysis)
ols_p2o4 <- ols(lac_linear_diff ~  log_endocab_igm_diff + lac_linear_base + log_endocab_igm_base, data=analysis)
ols_p3o4 <- ols(lac_linear_diff ~  log_lbp_diff + lac_linear_base + log_lbp_base, data=analysis)
ols_p4o4 <- ols(lac_linear_diff ~  log_cd14_diff + lac_linear_base + log_cd14_base, data=analysis)
ols_p1o5 <- ols(lac_quad_diff ~  log_endocab_igg_diff + lac_quad_base + log_endocab_igg_base, data=analysis)
ols_p2o5 <- ols(lac_quad_diff ~  log_endocab_igm_diff + lac_quad_base + log_endocab_igm_base, data=analysis)
ols_p3o5 <- ols(lac_quad_diff ~  log_lbp_diff + lac_quad_base + log_lbp_base, data=analysis)
ols_p4o5 <- ols(lac_quad_diff ~  log_cd14_diff + lac_quad_base + log_cd14_base, data=analysis)



## APPETITE PREDICTIVE OF ENERGY?
getols <- function(ols,outlabel,predlabel){
  ols_sum <- summary(ols)
  an1 <- data.frame(anova(ols))
  sum1.ests <- paste(format2(ols_sum[,4]/ols_sum[,3])," (",format2(ols_sum[,6]/ols_sum[,3]),", ",format2(ols_sum[,7]/ols_sum[,3]),")",sep="")
  pval1 <- sapply(an1$P[1:nrow(ols_sum)],myformat4)
  n <- round(ols$stats[1])
  r2 <- myformat3(ols$stats[4])
  labels1 <- c(paste("\\\\hspace{0.2in}Change in",predlabel),paste("\\\\hspace{0.2in}Baseline",outlabel),
              paste("\\\\hspace{0.2in}Baseline",predlabel))
  ols.table1 <- paste("\\\\hline ",paste("Change in",outlabel,"by",predlabel," & & & ",r2," & ",n)," \\\\\\\\",paste(paste(labels1,sum1.ests,pval1,sep=" & "),collapse=" \\\\\\\\ "),sep="")
  return(ols.table1)
}


p1o1_olstable <- getols(ols_p1o1,"TNF-alpha","log-Endocab IgG")
p2o1_olstable <- getols(ols_p2o1,"TNF-alpha","log-Endocab IgM")
p3o1_olstable <- getols(ols_p3o1,"TNF-alpha","log-LBP")
p4o1_olstable <- getols(ols_p4o1,"TNF-alpha","log-CD14")
p5o1_olstable <- getols(ols_p5o1,"TNF-alpha","log-Lac/Cr (linear)")
p6o1_olstable <- getols(ols_p6o1,"TNF-alpha","log-Lac/Cr (quadratic)")
p1o2_olstable <- getols(ols_p1o2,"CRP","log-Endocab IgG")
p2o2_olstable <- getols(ols_p2o2,"CRP","log-Endocab IgM")
p3o2_olstable <- getols(ols_p3o2,"CRP","log-LBP")
p4o2_olstable <- getols(ols_p4o2,"CRP","log-CD14")
p5o2_olstable <- getols(ols_p5o2,"CRP","log-Lac/Cr (linear)")
p6o2_olstable <- getols(ols_p6o2,"CRP","log-Lac/Cr (quadratic)")
p1o3_olstable <- getols(ols_p1o3,"CD163","log-Endocab IgG")
p2o3_olstable <- getols(ols_p2o3,"CD163","log-Endocab IgM")
p3o3_olstable <- getols(ols_p3o3,"CD163","log-LBP")
p4o3_olstable <- getols(ols_p4o3,"CD163","log-CD14")
p5o3_olstable <- getols(ols_p5o3,"CD163","log-Lac/Cr (linear)")
p6o3_olstable <- getols(ols_p6o3,"CD163","log-Lac/Cr (quadratic)")
p1o4_olstable <- getols(ols_p1o4,"Lac/Cr (linear)","log-Endocab IgG")
p2o4_olstable <- getols(ols_p2o4,"Lac/Cr (linear)","log-Endocab IgM")
p3o4_olstable <- getols(ols_p3o4,"Lac/Cr (linear)","log-LBP")
p4o4_olstable <- getols(ols_p4o4,"Lac/Cr (linear)","log-CD14")
p1o5_olstable <- getols(ols_p1o5,"Lac/Cr (quadratic)","log-Endocab IgG")
p2o5_olstable <- getols(ols_p2o5,"Lac/Cr (quadratic)","log-Endocab IgM")
p3o5_olstable <- getols(ols_p3o5,"Lac/Cr (quadratic)","log-LBP")
p4o5_olstable <- getols(ols_p4o5,"Lac/Cr (quadratic)","log-CD14")

o1_olstable <- paste(p1o1_olstable,p2o1_olstable,p3o1_olstable,p4o1_olstable,p5o1_olstable,p6o1_olstable,sep=" \\\\\\\\ ")
o2_olstable <- paste(p1o2_olstable,p2o2_olstable,p3o2_olstable,p4o2_olstable,p5o2_olstable,p6o2_olstable,sep=" \\\\\\\\ ")
o3_olstable <- paste(p1o3_olstable,p2o3_olstable,p3o3_olstable,p4o3_olstable,p5o3_olstable,p6o3_olstable,sep=" \\\\\\\\ ")
o4_olstable <- paste(p1o4_olstable,p2o4_olstable,p3o4_olstable,p4o4_olstable,sep=" \\\\\\\\ ")
o5_olstable <- paste(p1o5_olstable,p2o5_olstable,p3o5_olstable,p4o5_olstable,sep=" \\\\\\\\ ")

## APPETITE PREDICTIVE OF ENERGY?
getper <- function(ols,outlabel,predlabel,p=0.25){
  ols_sum <- summary(ols)
## BRYAN AND I WORKED ON THIS FORMULA ON SEPTEMBER 4, 2013
## E(Ya-Yb) = beta1 * log(Xa/Xb)
## So if Xb/Xa = e then then we see a beta1 change in deltaY.  This means that Xb saw an 171% increase from Xa
## To calculate the change in deltaY if there is a 25% increase in X, then multiply beta1 by 1.25.
  sum1.ests <- paste(format2(ols_sum[1,4]/ols_sum[1,3]*log(1+p))," (",format2(ifelse(p>0,ols_sum[1,6],ols_sum[1,7])/ols_sum[1,3]*log(1+p)),", ",format2(ifelse(p>0,ols_sum[1,7],ols_sum[1,6])/ols_sum[1,3]*log(1+p)),")",sep="")
  labels1 <- paste0("\\\\hspace{0.2in}",round(100*abs(p)),"\\\\% " , ifelse(p>0,"increase","decrease")," in 12 week ",predlabel)
  ols.table1 <- paste("\\\\hline ",paste("Change in",outlabel)," \\\\\\\\",paste(paste(labels1,sum1.ests,sep=" & "),collapse=" \\\\\\\\ "),sep="")
  return(ols.table1)
}


p1o1_olssum <- getper(ols_p1o1,"TNF-alpha","Endocab IgG",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p2o1_olssum <- getper(ols_p2o1,"TNF-alpha","Endocab IgM",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p3o1_olssum <- getper(ols_p3o1,"TNF-alpha","LBP",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p4o1_olssum <- getper(ols_p4o1,"TNF-alpha","CD14",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p5o1_olssum <- getper(ols_p5o1,"TNF-alpha","Lac/Cr (linear)",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p6o1_olssum <- getper(ols_p6o1,"TNF-alpha","Lac/Cr (quadratic)",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p1o2_olssum <- getper(ols_p1o2,"CRP","Endocab IgG",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p2o2_olssum <- getper(ols_p2o2,"CRP","Endocab IgM",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p3o2_olssum <- getper(ols_p3o2,"CRP","LBP",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p4o2_olssum <- getper(ols_p4o2,"CRP","CD14",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p5o2_olssum <- getper(ols_p5o2,"CRP","Lac/Cr (linear)",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p6o2_olssum <- getper(ols_p6o2,"CRP","Lac/Cr (quadratic)",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p1o3_olssum <- getper(ols_p1o3,"CD163","Endocab IgG",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p2o3_olssum <- getper(ols_p2o3,"CD163","Endocab IgM",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p3o3_olssum <- getper(ols_p3o3,"CD163","LBP",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p4o3_olssum <- getper(ols_p4o3,"CD163","CD14",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p5o3_olssum <- getper(ols_p5o3,"CD163","Lac/Cr (linear)",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p6o3_olssum <- getper(ols_p6o3,"CD163","Lac/Cr (quadratic)",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p1o4_olssum <- getper(ols_p1o4,"Lac/Cr (linear)","Endocab IgG",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p2o4_olssum <- getper(ols_p2o4,"Lac/Cr (linear)","Endocab IgM",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p3o4_olssum <- getper(ols_p3o4,"Lac/Cr (linear)","LBP",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p4o4_olssum <- getper(ols_p4o4,"Lac/Cr (linear)","CD14",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p1o5_olssum <- getper(ols_p1o5,"Lac/Cr (quadratic)","Endocab IgG",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p2o5_olssum <- getper(ols_p2o5,"Lac/Cr (quadratic)","Endocab IgM",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p3o5_olssum <- getper(ols_p3o5,"Lac/Cr (quadratic)","LBP",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))
p4o5_olssum <- getper(ols_p4o5,"Lac/Cr (quadratic)","CD14",p=c(-0.5,-0.25,0.25,0.5,1,exp(1)-1))

o1_olssum <- paste(p1o1_olssum,p2o1_olssum,p3o1_olssum,p4o1_olssum,p5o1_olssum,p6o1_olssum,sep=" \\\\\\\\ ")
o2_olssum <- paste(p1o2_olssum,p2o2_olssum,p3o2_olssum,p4o2_olssum,p5o2_olssum,p6o2_olssum,sep=" \\\\\\\\ ")
o3_olssum <- paste(p1o3_olssum,p2o3_olssum,p3o3_olssum,p4o3_olssum,p5o3_olssum,p6o3_olssum,sep=" \\\\\\\\ ")
o4_olssum <- paste(p1o4_olssum,p2o4_olssum,p3o4_olssum,p4o4_olssum,sep=" \\\\\\\\ ")
o5_olssum <- paste(p1o5_olssum,p2o5_olssum,p3o5_olssum,p4o5_olssum,sep=" \\\\\\\\ ")
