#############################################################
#
#   Program: mixed_model.R
#   Project: 
#   PI: 
#   Statistican/Programmer: Meridith Blevins, MS
#   Purpose: 
#   Notes: 
#   Created: 3 September 2013
#   Revisions: 
#     
#
#############################################################
format2 <- function(x){
    y <- format(round(x,2),nsmall=2,scientific=FALSE)
    return(y)
}
format3 <- function(x){
  if(x < 0.00095 & x > -0.00095){y <- format(round(x,4),nsmall=4,scientific=FALSE)}
  else{y <- format(round(x,3),nsmall=3,scientific=FALSE)}
    return(y)
}
format4 <- function(x){
    y <- format(round(x,4),nsmall=4,scientific=FALSE)
    return(y)
}
format5 <- function(x){
    y <- format(round(x,5),nsmall=5,scientific=FALSE)
    return(y)
}
library(nlme)

old <- lme(tnfa ~  igg, data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p1o1 <- lme(tnfa ~  log(igg), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p2o1 <- lme(tnfa ~  log(igm), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p3o1 <- lme(tnfa ~  log(lbp), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p4o1 <- lme(tnfa ~  log(cd14), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p5o1 <- lme(tnfa ~  log(lac_linear), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p6o1 <- lme(tnfa ~  log(lac_quad), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p1o2 <- lme(crp ~  log(igg), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p2o2 <- lme(crp ~  log(igm), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p3o2 <- lme(crp ~  log(lbp), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p4o2 <- lme(crp ~  log(cd14), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p5o2 <- lme(crp ~  lac_linear, data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p6o2 <- lme(crp ~  lac_quad, data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p1o3 <- lme(cd163 ~  log(igg), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p2o3 <- lme(cd163 ~  log(igm), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p3o3 <- lme(cd163 ~  log(lbp), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p4o3 <- lme(cd163 ~  log(cd14), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p5o3 <- lme(cd163 ~  log(lac_linear), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p6o3 <- lme(cd163 ~  log(lac_quad), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p1o4 <- lme(lac_linear ~  log(igg), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p2o4 <- lme(lac_linear ~  log(igm), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p3o4 <- lme(lac_linear ~  log(lbp), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p4o4 <- lme(lac_linear ~  log(cd14), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p1o5 <- lme(lac_quad ~  log(igg), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p2o5 <- lme(lac_quad ~  log(igm), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p3o5 <- lme(lac_quad ~  log(lbp), data=longfup, random=~1|id, na.action=na.omit,method="ML")
lmmnotime_p4o5 <- lme(lac_quad ~  log(cd14), data=longfup, random=~1|id, na.action=na.omit,method="ML")

## APPETITE PREDICTIVE OF ENERGY?
getlmmnotime <- function(lmm,outlabel,predlabel){
  lmm_sum <- summary(lmm)
### TOOK OUT EXP() - SEEMS WE DO NOT NEED TO TRANSFORM COEFFICIENTS (INTERNAL TO LME)
  sum1.est <- sapply(lmm_sum$tTable[1:2,1],format2)
  sum1.ll <- sapply((lmm_sum$tTable[1:2,1] - 1.96*lmm_sum$tTable[1:2,2]),format2)
  sum1.ul <- sapply((lmm_sum$tTable[1:2,1] + 1.96*lmm_sum$tTable[1:2,2]),format2)
  an1 <- anova(lmm)
  sum1.ests <- paste(sum1.est," (",sum1.ll,", ",sum1.ul,")",sep="")
  pval1 <- sapply(an1$"p-value",myformat4)
  n <- round(lmm$dim$N)
  labels1 <- c("\\\\hspace{0.2in}Intercept",paste0("\\\\hspace{0.2in}",predlabel))
  lmm.table1 <- paste("\\\\hline ",paste(outlabel,"by",predlabel)," & & & ",n," \\\\\\\\",paste(paste(labels1,sum1.ests,pval1,sep=" & "),collapse=" \\\\\\\\ "),sep="")
  return(lmm.table1)
}


p1o1_table_notime <- getlmmnotime(lmmnotime_p1o1,"TNF-alpha","log-Endocab IgG")
p2o1_table_notime <- getlmmnotime(lmmnotime_p2o1,"TNF-alpha","log-Endocab IgM")
p3o1_table_notime <- getlmmnotime(lmmnotime_p3o1,"TNF-alpha","log-LBP")
p4o1_table_notime <- getlmmnotime(lmmnotime_p4o1,"TNF-alpha","log-CD14")
p5o1_table_notime <- getlmmnotime(lmmnotime_p5o1,"TNF-alpha","log-Lac/Cr (linear)")
p6o1_table_notime <- getlmmnotime(lmmnotime_p6o1,"TNF-alpha","log-Lac/Cr (quadratic)")
p1o2_table_notime <- getlmmnotime(lmmnotime_p1o2,"CRP","log-Endocab IgG")
p2o2_table_notime <- getlmmnotime(lmmnotime_p2o2,"CRP","log-Endocab IgM")
p3o2_table_notime <- getlmmnotime(lmmnotime_p3o2,"CRP","log-LBP")
p4o2_table_notime <- getlmmnotime(lmmnotime_p4o2,"CRP","log-CD14")
p5o2_table_notime <- getlmmnotime(lmmnotime_p5o2,"CRP","log-Lac/Cr (linear)")
p6o2_table_notime <- getlmmnotime(lmmnotime_p6o2,"CRP","log-Lac/Cr (quadratic)")
p1o3_table_notime <- getlmmnotime(lmmnotime_p1o3,"CD163","log-Endocab IgG")
p2o3_table_notime <- getlmmnotime(lmmnotime_p2o3,"CD163","log-Endocab IgM")
p3o3_table_notime <- getlmmnotime(lmmnotime_p3o3,"CD163","log-LBP")
p4o3_table_notime <- getlmmnotime(lmmnotime_p4o3,"CD163","log-CD14")
p5o3_table_notime <- getlmmnotime(lmmnotime_p5o3,"CD163","log-Lac/Cr (linear)")
p6o3_table_notime <- getlmmnotime(lmmnotime_p6o3,"CD163","log-Lac/Cr (quadratic)")
p1o4_table_notime <- getlmmnotime(lmmnotime_p1o4,"Lac/Cr (linear)","log-Endocab IgG")
p2o4_table_notime <- getlmmnotime(lmmnotime_p2o4,"Lac/Cr (linear)","log-Endocab IgM")
p3o4_table_notime <- getlmmnotime(lmmnotime_p3o4,"Lac/Cr (linear)","log-LBP")
p4o4_table_notime <- getlmmnotime(lmmnotime_p4o4,"Lac/Cr (linear)","log-CD14")
p1o5_table_notime <- getlmmnotime(lmmnotime_p1o5,"Lac/Cr (quadratic)","log-Endocab IgG")
p2o5_table_notime <- getlmmnotime(lmmnotime_p2o5,"Lac/Cr (quadratic)","log-Endocab IgM")
p3o5_table_notime <- getlmmnotime(lmmnotime_p3o5,"Lac/Cr (quadratic)","log-LBP")
p4o5_table_notime <- getlmmnotime(lmmnotime_p4o5,"Lac/Cr (quadratic)","log-CD14")

o1_table_notime <- paste(p1o1_table_notime,p2o1_table_notime,p3o1_table_notime,p4o1_table_notime,p5o1_table_notime,p6o1_table_notime,sep=" \\\\\\\\ ")
o2_table_notime <- paste(p1o2_table_notime,p2o2_table_notime,p3o2_table_notime,p4o2_table_notime,p5o2_table_notime,p6o2_table_notime,sep=" \\\\\\\\ ")
o3_table_notime <- paste(p1o3_table_notime,p2o3_table_notime,p3o3_table_notime,p4o3_table_notime,p5o3_table_notime,p6o3_table_notime,sep=" \\\\\\\\ ")
o4_table_notime <- paste(p1o4_table_notime,p2o4_table_notime,p3o4_table_notime,p4o4_table_notime,sep=" \\\\\\\\ ")
o5_table_notime <- paste(p1o5_table_notime,p2o5_table_notime,p3o5_table_notime,p4o5_table_notime,sep=" \\\\\\\\ ")



