#############################################################
#
#   Program: mixed_model.R
#   Project: 
#   PI: 
#   Statistican/Programmer: Meridith Blevins, MS
#   Purpose: 
#   Notes: 
#   Created: 
#   Revisions: 
#     
#
#############################################################
longfupdata <- merge(longfup,data[c("memart_study_id","baseline_cd4","sex","age")],by.x="id",by.y="memart_study_id",all.x=TRUE)
lmmcov_p1o1 <- lme(tnfa ~  log(igg) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p2o1 <- lme(tnfa ~  log(igm) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p3o1 <- lme(tnfa ~  log(lbp) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p4o1 <- lme(tnfa ~  log(cd14) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p5o1 <- lme(tnfa ~  log(lac_linear) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p6o1 <- lme(tnfa ~  log(lac_quad) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p1o2 <- lme(crp ~  log(igg) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p2o2 <- lme(crp ~  log(igm) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p3o2 <- lme(crp ~  log(lbp) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p4o2 <- lme(crp ~  log(cd14) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p5o2 <- lme(crp ~  lac_linear +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p6o2 <- lme(crp ~  lac_quad +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p1o3 <- lme(cd163 ~  log(igg) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p2o3 <- lme(cd163 ~  log(igm) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p3o3 <- lme(cd163 ~  log(lbp) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p4o3 <- lme(cd163 ~  log(cd14) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p5o3 <- lme(cd163 ~  log(lac_linear) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p6o3 <- lme(cd163 ~  log(lac_quad) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p1o4 <- lme(lac_linear ~  log(igg) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p2o4 <- lme(lac_linear ~  log(igm) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p3o4 <- lme(lac_linear ~  log(lbp) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p4o4 <- lme(lac_linear ~  log(cd14) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p1o5 <- lme(lac_quad ~  log(igg) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p2o5 <- lme(lac_quad ~  log(igm) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p3o5 <- lme(lac_quad ~  log(lbp) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")
lmmcov_p4o5 <- lme(lac_quad ~  log(cd14) +  sex + age + sqrt(baseline_cd4), data=longfupdata, random=~1|id, na.action=na.omit,method="ML")

## APPETITE PREDICTIVE OF ENERGY?
getlmmcov <- function(lmm,outlabel,predlabel){
  lmm_sum <- summary(lmm)
### TOOK OUT EXP() - SEEMS WE DO NOT NEED TO TRANSFORM COEFFICIENTS (INTERNAL TO LME)
  sum1.est <- sapply(lmm_sum$tTable[1:5,1],format2)
  sum1.ll <- sapply((lmm_sum$tTable[1:5,1] - 1.96*lmm_sum$tTable[1:5,2]),format2)
  sum1.ul <- sapply((lmm_sum$tTable[1:5,1] + 1.96*lmm_sum$tTable[1:5,2]),format2)
  an1 <- anova(lmm)
  sum1.ests <- paste(sum1.est," (",sum1.ll,", ",sum1.ul,")",sep="")
  pval1 <- sapply(an1$"p-value",myformat4)
  n <- round(lmm$dim$N)
  labels1 <- c("\\\\hspace{0.2in}Intercept",paste0("\\\\hspace{0.2in}",c(predlabel,"Male","Age","sqrt-CD4")))
  lmm.table1 <- paste("\\\\hline ",paste(outlabel,"by",predlabel)," & & & ",n," \\\\\\\\",paste(paste(labels1,sum1.ests,pval1,sep=" & "),collapse=" \\\\\\\\ "),sep="")
  return(lmm.table1)
}


p1o1_covtable_notime <- getlmmcov(lmmcov_p1o1,"TNF-alpha","log-Endocab IgG")
p2o1_covtable_notime <- getlmmcov(lmmcov_p2o1,"TNF-alpha","log-Endocab IgM")
p3o1_covtable_notime <- getlmmcov(lmmcov_p3o1,"TNF-alpha","log-LBP")
p4o1_covtable_notime <- getlmmcov(lmmcov_p4o1,"TNF-alpha","log-CD14")
p5o1_covtable_notime <- getlmmcov(lmmcov_p5o1,"TNF-alpha","log-Lac/Cr (linear)")
p6o1_covtable_notime <- getlmmcov(lmmcov_p6o1,"TNF-alpha","log-Lac/Cr (quadratic)")
p1o2_covtable_notime <- getlmmcov(lmmcov_p1o2,"CRP","log-Endocab IgG")
p2o2_covtable_notime <- getlmmcov(lmmcov_p2o2,"CRP","log-Endocab IgM")
p3o2_covtable_notime <- getlmmcov(lmmcov_p3o2,"CRP","log-LBP")
p4o2_covtable_notime <- getlmmcov(lmmcov_p4o2,"CRP","log-CD14")
p5o2_covtable_notime <- getlmmcov(lmmcov_p5o2,"CRP","log-Lac/Cr (linear)")
p6o2_covtable_notime <- getlmmcov(lmmcov_p6o2,"CRP","log-Lac/Cr (quadratic)")
p1o3_covtable_notime <- getlmmcov(lmmcov_p1o3,"CD163","log-Endocab IgG")
p2o3_covtable_notime <- getlmmcov(lmmcov_p2o3,"CD163","log-Endocab IgM")
p3o3_covtable_notime <- getlmmcov(lmmcov_p3o3,"CD163","log-LBP")
p4o3_covtable_notime <- getlmmcov(lmmcov_p4o3,"CD163","log-CD14")
p5o3_covtable_notime <- getlmmcov(lmmcov_p5o3,"CD163","log-Lac/Cr (linear)")
p6o3_covtable_notime <- getlmmcov(lmmcov_p6o3,"CD163","log-Lac/Cr (quadratic)")
p1o4_covtable_notime <- getlmmcov(lmmcov_p1o4,"Lac/Cr (linear)","log-Endocab IgG")
p2o4_covtable_notime <- getlmmcov(lmmcov_p2o4,"Lac/Cr (linear)","log-Endocab IgM")
p3o4_covtable_notime <- getlmmcov(lmmcov_p3o4,"Lac/Cr (linear)","log-LBP")
p4o4_covtable_notime <- getlmmcov(lmmcov_p4o4,"Lac/Cr (linear)","log-CD14")
p1o5_covtable_notime <- getlmmcov(lmmcov_p1o5,"Lac/Cr (quadratic)","log-Endocab IgG")
p2o5_covtable_notime <- getlmmcov(lmmcov_p2o5,"Lac/Cr (quadratic)","log-Endocab IgM")
p3o5_covtable_notime <- getlmmcov(lmmcov_p3o5,"Lac/Cr (quadratic)","log-LBP")
p4o5_covtable_notime <- getlmmcov(lmmcov_p4o5,"Lac/Cr (quadratic)","log-CD14")

o1_covtable_notime <- paste(p1o1_covtable_notime,p2o1_covtable_notime,p3o1_covtable_notime,p4o1_covtable_notime,p5o1_covtable_notime,p6o1_covtable_notime,sep=" \\\\\\\\ ")
o2_covtable_notime <- paste(p1o2_covtable_notime,p2o2_covtable_notime,p3o2_covtable_notime,p4o2_covtable_notime,p5o2_covtable_notime,p6o2_covtable_notime,sep=" \\\\\\\\ ")
o3_covtable_notime <- paste(p1o3_covtable_notime,p2o3_covtable_notime,p3o3_covtable_notime,p4o3_covtable_notime,p5o3_covtable_notime,p6o3_covtable_notime,sep=" \\\\\\\\ ")
o4_covtable_notime <- paste(p1o4_covtable_notime,p2o4_covtable_notime,p3o4_covtable_notime,p4o4_covtable_notime,sep=" \\\\\\\\ ")
o5_covtable_notime <- paste(p1o5_covtable_notime,p2o5_covtable_notime,p3o5_covtable_notime,p4o5_covtable_notime,sep=" \\\\\\\\ ")



