#############################################################
#
#   Program: table1.R
#   Project: 
#   PI: 
#   Statistican/Programmer: Meridith Blevins, MS
#   Purpose: 
#   Notes: 
#   Created: 24 October 2012
#   Revisions: 
#     
#
#############################################################


## RECORD 0 BMI as MISSING
data$x12_wk_bmi[data$x12_wk_bmi==0] <- NA

## RECORD LAC < 0 as 0
data$lac_linear_base[data$lac_linear_base<=0] <- NA
data$lac_linear_12wk[data$lac_linear_12wk<=0] <- NA
data$lac_quad_base[data$lac_quad_base<=0] <- NA
data$lac_quad_12wk[data$lac_quad_12wk<=0] <- NA

    
## CALCULATE CHANGE IN LAB VALUES OVER 12 WEEKS
data$endocab_igg_diff <- data$endocab_igg_12wk - data$endocab_igg_base
data$endocab_igm_diff <- data$endocab_igm_12wk - data$endocab_igm_base
data$tnf_ar1_diff <- data$tnf_ar1_12wk - data$tnf_ar1_base
data$lbp_diff <- data$lbp_12wk - data$lbp_base
data$cd163_diff <- data$cd163_12wk - data$cd163_base
data$cd14_diff <- data$cd14_12wk_mgml - data$cd14_base_mgml
data$crp_diff <- data$crp_12wk_mgl - data$crp_base_mgl
data$lac_linear_diff <- data$lac_linear_12wk - data$lac_linear_base
data$lac_quad_diff <- data$lac_quad_12wk - data$lac_quad_base

data$log_endocab_igg_diff <- log(data$endocab_igg_12wk) - log(data$endocab_igg_base)
data$log_endocab_igm_diff <- log(data$endocab_igm_12wk) - log(data$endocab_igm_base)
data$log_tnf_ar1_diff <- log(data$tnf_ar1_12wk) - log(data$tnf_ar1_base)
data$log_lbp_diff <- log(data$lbp_12wk) - log(data$lbp_base)
data$log_cd163_diff <- log(data$cd163_12wk) - log(data$cd163_base)
data$log_cd14_diff <- log(data$cd14_12wk_mgml) - log(data$cd14_base_mgml)
data$log_crp_diff <- log(data$crp_12wk_mgl) - log(data$crp_base_mgl)
data$log_lac_linear_diff <- log(data$lac_linear_12wk) - log(data$lac_linear_base)
data$log_lac_quad_diff <- log(data$lac_quad_12wk) - log(data$lac_quad_base)

data$log_endocab_igg_base <- log(data$endocab_igg_base)
data$log_endocab_igm_base <- log(data$endocab_igm_base)
data$log_tnf_ar1_base <- log(data$tnf_ar1_base)
data$log_lbp_base <-   log(data$lbp_base)
data$log_cd163_base <- log(data$cd163_base)
data$log_cd14_base <- log(data$cd14_base_mgml)
data$log_crp_base <- log(data$crp_base_mgl)
data$log_lac_linear_base <- log(data$lac_linear_base)
data$log_lac_quad_base <- log(data$lac_quad_base)

## GET PATIENTS WITH AT LEAST 1 12 WEEK LAB
haslab <- round(apply(with(data,data.frame(endocab_igg_diff,endocab_igm_diff,lbp_diff,cd14_diff,tnf_ar1_diff,crp_diff,cd163_diff,lac_linear_diff,lac_quad_diff)),1,function(var) sum(!is.na(var))))
data$ltfu <- as.factor(ifelse(haslab==0,"Lab LTFU","Not Lab LTFU"))

T1.head <- printheader(table(data$ltfu),pval=TRUE)

sex.n1 <- getnptex(data$sex,by=data$ltfu,rowlabel=c("Female","Male"),label="Sex")
age.m1 <- getmedtex(data$age,by=data$ltfu,label="Age (years)",digits=0)
wgt.m1 <- getmedtex(data$weight,by=data$ltfu,label="Weight (kg)",digits=1)
hgt.m1 <- getmedtex(data$height,by=data$ltfu,label="Height (m)",digits=1)
bmi.m1 <- getmedtex(data$baseline_bmi,by=data$ltfu,label="Baseline BMI (kg/m$^2$)",digits=1)
bmi12.m1 <- getmedtex(data$x12_wk_bmi,by=data$ltfu,label="Week 12 BMI (kg/m$^2$)",digits=1)
hgb.m1 <- getmedtex(data$baseline_hemoglobin,by=data$ltfu,label="Hemoglobin (g/dL)",digits=1)
cd4.m1 <- getmedtex(data$baseline_cd4,by=data$ltfu,label="CD4 (count/$\\\\mu$L)",digits=0)
art.n1 <- getnptex(data$art_start,by=data$ltfu,label="Initiated cART")

lab1t1.m1 <- getmeduni(data$endocab_igg_base,label="Baseline Endocab IgG",digits=1,lower.label=FALSE)
lab1t2.m1 <- getmeduni(data$endocab_igg_12wk,label="Week 12 Endocab IgG",digits=1,lower.label=FALSE)
lab2t1.m1 <- getmeduni(data$endocab_igm_base,label="Baseline Endocab IgM",digits=1,lower.label=FALSE)
lab2t2.m1 <- getmeduni(data$endocab_igm_12wk,label="Week 12 Endocab IgM",digits=1,lower.label=FALSE)
lab3t1.m1 <- getmeduni(data$lbp_base,label="Baseline LBP",digits=1,lower.label=FALSE)
lab3t2.m1 <- getmeduni(data$lbp_12wk,label="Week 12 LBP",digits=1,lower.label=FALSE)
lab4t1.m1 <- getmeduni(data$cd14_base_mgml,label="Baseline CD14",digits=1,lower.label=FALSE)
lab4t2.m1 <- getmeduni(data$cd14_12wk_mgml,label="Week 12 CD14",digits=1,lower.label=FALSE)
lab5t1.m1 <- getmeduni(data$tnf_ar1_base,label="Baseline TNF$\\\\alpha$",digits=1,lower.label=FALSE)
lab5t2.m1 <- getmeduni(data$tnf_ar1_12wk,label="Week 12 TNF$\\\\alpha$",digits=1,lower.label=FALSE)
lab6t1.m1 <- getmeduni(data$crp_base_mgl,label="Baseline CRP",digits=1,lower.label=FALSE)
lab6t2.m1 <- getmeduni(data$crp_12wk_mgl,label="Week 12 CRP",digits=1,lower.label=FALSE)
lab7t1.m1 <- getmeduni(data$cd163_base,label="Baseline CD163",digits=1,lower.label=FALSE)
lab7t2.m1 <- getmeduni(data$cd163_12wk,label="Week 12 CD163",digits=1,lower.label=FALSE)
lab8t1.m1 <- getmeduni(data$lac_linear_base,label="Baseline Lac/Cr (linear)",digits=1,lower.label=FALSE)
lab8t2.m1 <- getmeduni(data$lac_linear_12wk,label="Week 12 Lac/Cr (linear)",digits=1,lower.label=FALSE)
lab9t1.m1 <- getmeduni(data$lac_quad_base,label="Baseline Lac/Cr (quadratic)",digits=1,lower.label=FALSE)
lab9t2.m1 <- getmeduni(data$lac_quad_12wk,label="Week 12 Lac/Cr (quadratic)",digits=1,lower.label=FALSE)


lab1d.m1 <- getmeduni(data$endocab_igg_diff,label="Change in Endocab IgG",digits=1,lower.label=FALSE)
lab2d.m1 <- getmeduni(data$endocab_igm_diff,label="Change in Endocab IgM",digits=1,lower.label=FALSE)
lab3d.m1 <- getmeduni(data$lbp_diff,label="Change in LBP",digits=1,lower.label=FALSE)
lab4d.m1 <- getmeduni(data$cd14_diff,label="Change in CD14",digits=1,lower.label=FALSE)
lab5d.m1 <- getmeduni(data$tnf_ar1_diff,label="Change in TNF$\\\\alpha$",digits=1,lower.label=FALSE)
lab6d.m1 <- getmeduni(data$crp_diff,label="Change in CRP",digits=1,lower.label=FALSE)
lab7d.m1 <- getmeduni(data$cd163_diff,label="Change in CD163",digits=1,lower.label=FALSE)
lab8d.m1 <- getmeduni(data$lac_linear_diff,label="Change in Lac/Cr (linear)",digits=1,lower.label=FALSE)
lab9d.m1 <- getmeduni(data$lac_quad_diff,label="Change in Lac/Cr (quadratic)",digits=1,lower.label=FALSE)


#sym1.n1 <- getnp1lineuni(var=ifelse(adults$diarrhea==1,1,NA),rowlabel="Diarrhea",indent=TRUE,inc.pval=TRUE)
table1 <- paste(sex.n1,age.m1,bmi.m1,bmi12.m1$line.incmiss,hgb.m1$line.incmiss,cd4.m1,art.n1,sep=" \\\\\\\\ ")
#                lab1t1.m1$line.incmiss,lab1t2.m1$line.incmiss,lab1d.m1$line.incmiss,lab2t1.m1$line.incmiss,lab2t2.m1$line.incmiss,lab2d.m1$line.incmiss,
#                lab3t1.m1$line.incmiss,lab3t2.m1$line.incmiss,lab3d.m1$line.incmiss,lab4t1.m1$line.incmiss,lab4t2.m1$line.incmiss,lab4d.m1$line.incmiss,
#                lab5t1.m1$line.incmiss,lab5t2.m1$line.incmiss,lab5d.m1$line.incmiss,lab6t1.m1$line.incmiss,lab6t2.m1$line.incmiss,lab6d.m1$line.incmiss,
#                lab7t1.m1$line.incmiss,lab7t2.m1$line.incmiss,lab7d.m1$line.incmiss,



## GET PATIENTS WITH AT LEAST 1 12 WEEK LAB
data$lab3 <- as.factor(ifelse(haslab>3,"More than 3 lab pairs","1-3 lab pairs"))
labdata <- data[haslab!=0,]

T2.head <- printheader(table(labdata$lab3),pval=TRUE)

sex.n2 <- getnptex(labdata$sex,by=labdata$lab3,rowlabel=c("Female","Male"),label="Sex")
age.m2 <- getmedtex(labdata$age,by=labdata$lab3,label="Age (years)",digits=0)
wgt.m2 <- getmedtex(labdata$weight,by=labdata$lab3,label="Weight (kg)",digits=1)
hgt.m2 <- getmedtex(labdata$height,by=labdata$lab3,label="Height (m)",digits=1)
bmi.m2 <- getmedtex(labdata$baseline_bmi,by=labdata$lab3,label="Baseline BMI (kg/m$^2$)",digits=1)
bmi12.m2 <- getmedtex(labdata$x12_wk_bmi,by=labdata$lab3,label="Week 12 BMI (kg/m$^2$)",digits=1)
hgb.m2 <- getmedtex(labdata$baseline_hemoglobin,by=labdata$lab3,label="Hemoglobin (g/dL)",digits=1)
cd4.m2 <- getmedtex(labdata$baseline_cd4,by=labdata$lab3,label="CD4 (count/$\\\\mu$L)",digits=0)
art.n2 <- getnptex(labdata$art_start,by=labdata$lab3,label="Initiated cART",inc.pval=FALSE)

ptchartable2 <- paste(sex.n2,age.m2,bmi.m2,bmi12.m2$line.incmiss,hgb.m2$line.incmiss,cd4.m2,art.n2,sep=" \\\\\\\\ ")



analysis <- data[data$ltfu=="Not Lab LTFU",]  ## KEEP THOSE WITH >50% OF LABS
sex.n2 <- getnpuni(analysis$sex,rowlabel=c("Female","Male"),label="Sex")
age.m2 <- getmeduni(analysis$age,label="Age (years)",digits=0)
wgt.m2 <- getmeduni(analysis$weight,label="Weight (kg)",digits=1)
hgt.m2 <- getmeduni(analysis$height,label="Height (m)",digits=1)
bmi.m2 <- getmeduni(analysis$baseline_bmi,label="Baseline BMI (kg/m$^2$)",digits=1)
bmi12.m2 <- getmeduni(analysis$x12_wk_bmi,label="Week 12 BMI (kg/m$^2$)",digits=1)
hgb.m2 <- getmeduni(analysis$baseline_hemoglobin,label="Hemoglobin (g/dL)",digits=1)
cd4.m2 <- getmeduni(analysis$baseline_cd4,label="CD4 (count/$\\\\mu$L)",digits=0)
art.n2 <- getnp1lineuni(ifelse(analysis$art_start=="yes",1,NA),rowlabel="Initiated cART",indent=FALSE)

getmedmeanmiss <- function(var,label){
   ms <- sum(is.na(var))
   msper <- round(ms/length(var)*100)
   paste(label,medianIQR(var),meanSD(var),paste0(ms," (", msper,"\\\\%)"),sep=" & ")
}
lab1t1.m2 <- getmedmeanmiss(analysis$endocab_igg_base,label="Baseline Endocab IgG")
lab1t2.m2 <- getmedmeanmiss(analysis$endocab_igg_12wk,label="Week 12 Endocab IgG")
lab2t1.m2 <- getmedmeanmiss(analysis$endocab_igm_base,label="Baseline Endocab IgM")
lab2t2.m2 <- getmedmeanmiss(analysis$endocab_igm_12wk,label="Week 12 Endocab IgM")
lab3t1.m2 <- getmedmeanmiss(analysis$lbp_base,label="Baseline LBP")
lab3t2.m2 <- getmedmeanmiss(analysis$lbp_12wk,label="Week 12 LBP")
lab4t1.m2 <- getmedmeanmiss(analysis$cd14_base_mgml,label="Baseline CD14")
lab4t2.m2 <- getmedmeanmiss(analysis$cd14_12wk_mgml,label="Week 12 CD14")
lab5t1.m2 <- getmedmeanmiss(analysis$tnf_ar1_base,label="Baseline TNF$\\\\alpha$")
lab5t2.m2 <- getmedmeanmiss(analysis$tnf_ar1_12wk,label="Week 12 TNF$\\\\alpha$")
lab6t1.m2 <- getmedmeanmiss(analysis$crp_base_mgl,label="Baseline CRP")
lab6t2.m2 <- getmedmeanmiss(analysis$crp_12wk_mgl,label="Week 12 CRP")
lab7t1.m2 <- getmedmeanmiss(analysis$cd163_base,label="Baseline CD163")
lab7t2.m2 <- getmedmeanmiss(analysis$cd163_12wk,label="Week 12 CD163")
lab8t1.m2 <- getmedmeanmiss(analysis$lac_linear_base,label="Baseline Lac/Cr (linear)")
lab8t2.m2 <- getmedmeanmiss(analysis$lac_linear_12wk,label="Week 12 Lac/Cr (linear)")
lab9t1.m2 <- getmedmeanmiss(analysis$lac_quad_base,label="Baseline Lac/Cr (quadratic)")
lab9t2.m2 <- getmedmeanmiss(analysis$lac_quad_12wk,label="Week 12 Lac/Cr (quadratic)")



lab1d.m2 <- getmedmeanmiss(analysis$endocab_igg_diff,label="Change in Endocab IgG")
lab2d.m2 <- getmedmeanmiss(analysis$endocab_igm_diff,label="Change in Endocab IgM")
lab3d.m2 <- getmedmeanmiss(analysis$lbp_diff,label="Change in LBP")
lab4d.m2 <- getmedmeanmiss(analysis$cd14_diff,label="Change in CD14")
lab5d.m2 <- getmedmeanmiss(analysis$tnf_ar1_diff,label="Change in TNF$\\\\alpha$")
lab6d.m2 <- getmedmeanmiss(analysis$crp_diff,label="Change in CRP")
lab7d.m2 <- getmedmeanmiss(analysis$cd163_diff,label="Change in CD163")
lab8d.m2 <- getmedmeanmiss(analysis$lac_linear_diff,label="Change in Lac/Cr (linear)")
lab9d.m2 <- getmedmeanmiss(analysis$lac_quad_diff,label="Change in Lac/Cr (quadratic)")



table2 <- paste(sex.n2,age.m2,bmi.m2,bmi12.m2$line.incmiss,hgb.m2$line.incmiss,cd4.m2,art.n2,
                sep=" \\\\\\\\ ")


table3 <- paste(lab1t1.m2,lab1t2.m2,lab1d.m2,lab2t1.m2,lab2t2.m2,lab2d.m2,
                lab3t1.m2,lab3t2.m2,lab3d.m2,lab4t1.m2,lab4t2.m2,lab4d.m2,
                lab5t1.m2,lab5t2.m2,lab5d.m2,lab6t1.m2,lab6t2.m2,lab6d.m2,
                lab7t1.m2,lab7t2.m2,lab7d.m2,
                lab8t1.m2,lab8t2.m2,lab8d.m2,
                lab9t1.m2,lab9t2.m2,lab9d.m2,sep=" \\\\\\\\ ")



longfup <- data.frame(tnfa=c(analysis$tnf_ar1_base,analysis$tnf_ar1_12wk),
                   crp=c(analysis$crp_base_mgl,analysis$crp_12wk_mgl),
                   cd163=c(analysis$cd163_base,analysis$cd163_12wk),
                   igg=c(analysis$endocab_igg_base,analysis$endocab_igg_12wk),
                   igm=c(analysis$endocab_igm_base,analysis$endocab_igm_12wk),
                   lbp=c(analysis$lbp_base,analysis$lbp_12wk),
                   cd14=c(analysis$cd14_base_mgml,analysis$cd14_12wk_mgml),
                   lac_linear=c(analysis$lac_linear_base,analysis$lac_linear_12wk),
                   lac_quad=c(analysis$lac_quad_base,analysis$lac_quad_12wk),
                   time=c(rep(0,nrow(analysis)),rep(1,nrow(analysis))),
                   base_tnfa=rep(analysis$tnf_ar1_base,2),
                   base_crp=rep(analysis$crp_base_mgl,2),
                   base_cd163=rep(analysis$cd163_base,2),
                   id=rep(analysis$memart_study_id,2))
                      


#wilcox.test(analysis$lac_linear_base,analysis$lac_linear_12wk)
#median(analysis$lac_linear_base,na.rm=TRUE)
#median(analysis$lac_linear_12wk,na.rm=TRUE)


